SystemOrganization addCategory: #SeqColSnake!

TestCase subclass: #SeqColSnakeTest
	instanceVariableNames: 'scs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeqColSnake'!

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/31/2013 21:19'!
assert31Stepping.
	self assert: (scs snake asArray) equals: {1. 2. 3}.
	scs step.
	self assert: (scs snake asArray) equals: {2. 3. 4}.
	scs step.
	self assert: (scs snake asArray) equals: {3. 4. 5}.! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/31/2013 21:20'!
assert32Stepping
	self assert: (scs snake asArray) equals: {1. 2. 3}.
	scs step.
	self assert: (scs snake asArray) equals: {3. 4. 5}.
	scs step.
	self assert: (scs snake asArray) equals: {5. 6. 7}.! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/31/2013 21:20'!
assert33Stepping.
	self assert: (scs snake asArray) equals: {1. 2. 3}.
	scs step.
	self assert: (scs snake asArray) equals: {4. 5. 6}.
	scs step.
	self assert: (scs snake asArray) equals: {7. 8. 9}.! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/31/2013 21:08'!
sampleCollection
	^ 1 to: 9! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/31/2013 21:07'!
setUp
	super setUp.
	scs := SeqColSnake new.! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/31/2014 21:21'!
testAllSatisfy
	scs sequenceableCollection: self sampleCollection length: 3 proceeding: 2.
	self assert: (scs allSatisfy: [:snake| snake first < snake second and: [ snake second < snake third ] ]).
	self deny: (scs allSatisfy: [:snake| (snake sum rem: 4) = 0]).! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/1/2013 12:35'!
testDo
	|tape|
	scs sequenceableCollection: self sampleCollection length: 3 proceeding: 2.
	tape := OrderedCollection new.
	scs do: [:snake| tape add: snake asArray ].
	self assert: tape asArray equals: {{1. 2. 3}. {3. 4. 5}. {5. 6. 7}. {7. 8. 9}}! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/1/2013 12:34'!
testLength3Overlapping0
	scs sequenceableCollection: self sampleCollection length: 3 overlapping: 0.
	self assert33Stepping.! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/1/2013 12:34'!
testLength3Overlapping1
	scs sequenceableCollection: self sampleCollection length: 3 overlapping: 1.
	self assert32Stepping.! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/1/2013 12:34'!
testLength3Overlapping2
	scs sequenceableCollection: self sampleCollection length: 3 overlapping: 2.
	self assert31Stepping.! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/1/2013 12:35'!
testLength3Proceeding1
	scs sequenceableCollection: self sampleCollection length: 3 proceeding: 1.
	self assert31Stepping.
! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/1/2013 12:35'!
testLength3Proceeding2
	scs sequenceableCollection: self sampleCollection length: 3 proceeding: 2.
	self assert32Stepping.! !

!SeqColSnakeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/1/2013 12:35'!
testLength3Proceeding3
	scs sequenceableCollection: self sampleCollection length: 3 proceeding: 3.
	self assert33Stepping.! !

Object subclass: #SeqColSnake
	instanceVariableNames: 'length proceeding snake rotator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeqColSnake'!

!SeqColSnake methodsFor: 'changing' stamp: 'HwaJong 3/31/2014 21:17'!
allSatisfy: aBlockClosure
	self do: 
		[ :eachSnake|
		(aBlockClosure value: snake)
			ifFalse: [ ^false ] ].
	^true! !

!SeqColSnake methodsFor: 'changing' stamp: 'HwaJong 8/31/2013 21:30'!
do: aBlockClosure 
	|n|
	n  :=  rotator size / proceeding. 
	n isInteger
		ifFalse: [self error: 'snake length is not exact for do: '].
	aBlockClosure value: snake. 
	n timesRepeat: [self step. aBlockClosure value: snake].! !

!SeqColSnake methodsFor: 'changing' stamp: 'HwaJong 8/31/2013 19:28'!
length: anInteger 
	length := anInteger! !

!SeqColSnake methodsFor: 'answering' stamp: 'HwaJong 8/31/2013 19:46'!
proceeding
	^proceeding! !

!SeqColSnake methodsFor: 'changing' stamp: 'HwaJong 9/1/2013 12:35'!
sequenceableCollection: aSequenceableCollection length: int1 overlapping: int2

	self sequenceableCollection: aSequenceableCollection length: int1 proceeding: (int1 - int2)! !

!SeqColSnake methodsFor: 'changing' stamp: 'HwaJong 9/1/2013 12:35'!
sequenceableCollection: aSequenceableCollection length: int1 proceeding: int2

	length := int1.
	proceeding := int2.
	rotator := OrderedCollection withAll: aSequenceableCollection.
	snake := OrderedCollection withAll: (rotator removeFirst: length).! !

!SeqColSnake methodsFor: 'answering' stamp: 'HwaJong 8/31/2013 19:46'!
snake
	^ snake! !

!SeqColSnake methodsFor: 'changing' stamp: 'HwaJong 9/1/2013 12:29'!
step
	
	[:a :b | a addAllLast: (b removeFirst: self proceeding) ]
		value: rotator value: snake;
		value: snake value: rotator! !
